## altos 1.4.1

=== doc/Makefile ===
#
#	http://docbook.sourceforge.net/release/xsl/current/README
#

RELNOTES=\
	release-notes-0.7.1.html \
	release-notes-0.8.html \
	release-notes-0.9.html \
	release-notes-0.9.2.html \
	release-notes-1.0.1.html \
	release-notes-1.1.html \
	release-notes-1.1.1.html \
	release-notes-1.2.html \
	release-notes-1.2.1.html \
	release-notes-1.3.html \
	release-notes-1.3.1.html \
	release-notes-1.3.2.html \
	release-notes-1.4.html \
	release-notes-1.4.1.html

PICTURES=\
	altosui.png \
	ascent.png \
	configure-altimeter.png \
	configure-altosui.png \
	configure-groundstation.png \
	configure-pyro.png \
	descent.png \
	device-selection.png \
	easymini-top.jpg \
	fire-igniter.png \
	graph-configure.png \
	graph-map.png \
	graph.png \
	graph-stats.png \
	landed.png \
	launch-pad.png \
	load-maps.png \
	micropeak-app.png \
	micropeak-back.jpg \
	micropeak-device-dialog.png \
	micropeak-dime.jpg \
	micropeak-download.png \
	micropeak-graph-configure.png \
	micropeak-graph.png \
	micropeak-preferences.png \
	micropeak-raw-data.png \
	micropeak-save-dialog.png \
	micropeak-statistics.png \
	MicroPeakUSB-2.0-inuse.jpg \
	MicroPeakUSB-2.0.jpg \
	scan-channels.png \
	site-map.png \
	table.png \
	telemega-v1.0-top.jpg \
	telemetrum-v1.1-thside.jpg \
	telemini-v1-top.jpg \
	telemini-v2-top.jpg

SVG=\
	easymini.svg \
	telemega.svg \
	telemetrum.svg \
	telemini.svg

RELNOTES_XSL=$(RELNOTES:.html=.xsl)
HTML=altusmetrum.html altos.html telemetry.html companion.html micropeak.html telegps.html $(RELNOTES)
PDF=altusmetrum.pdf altos.pdf telemetry.pdf companion.pdf micropeak.pdf telegps.pdf \
	telemetrum-outline.pdf telemega-outline.pdf easymini-outline.pdf
HTMLSTYLE=/usr/share/xml/docbook/stylesheet/docbook-xsl/html/docbook.xsl
FOSTYLE=xorg-fo.xsl
TEMPLATES=titlepage.templates.xsl
PDFSTYLE=
IMAGES=$(PICTURES) $(SVG)
DOC=$(HTML) $(PDF) $(IMAGES)

.SUFFIXES: .xml .xsl .html .pdf

XSLTFLAGS=--stringparam section.autolabel 1 --xinclude

.xsl.html:
	xsltproc $(XSLTFLAGS) -o $@ $(HTMLSTYLE) $*.xsl

.xsl.pdf:
	xmlto -x $(FOSTYLE) --with-fop pdf $*.xsl

.xml.xsl:
	xsltproc --output $@ /usr/share/xml/docbook/stylesheet/docbook-xsl/template/titlepage.xsl $*.xml

all:	$(HTML) $(PDF)

install:	all

publish:	$(DOC)
	cp $(DOC) /home/bdale/web/altusmetrum/AltOS/doc/
	(cd /home/bdale/web/altusmetrum ; \
	 git add /home/bdale/web/altusmetrum/AltOS/doc/* ; \
	 echo "update docs" | \
	 git commit -F - /home/bdale/web/altusmetrum/AltOS/doc/* ; \
	 git push)

clean:
	rm -f $(HTML) $(PDF) $(TEMPLATES)

distclean:
	rm -f $(HTML) $(PDF)

altusmetrum.html: $(RELNOTES_XSL) $(IMAGES)
altusmetrum.pdf: $(RELNOTES_XSL) $(IMAGES)

telegps.html: $(RELNOTES_XSL) $(IMAGES)
telegps.pdf: $(RELNOTES_XSL) $(IMAGES)

$(PDF): $(FOSTYLE) $(TEMPLATES)

indent:		altusmetrum.xsl
	xmlindent -i 2 < altusmetrum.xsl > altusmetrum.new

=== src/Makefile ===
#
# AltOS build
#

vpath make-altitude util
vpath make-altitude-pa util
vpath make-kalman util
vpath make-whiten util
vpath kalman.5c kalman
vpath kalman_filter.5c kalman
vpath kalman_micro.5c kalman
vpath load_csv.5c kalman
vpath matrix.5c kalman

include Version
TOPDIR=.
include Makedefs

SDCCDIRS=\
	telemetrum-v1.2 telemetrum-v1.1 telemetrum-v1.0 \
	teledongle-v0.2 \
	telemini-v1.0 telemini-v2.0 \
	telebt-v1.0 \
	teleterra-v0.2 teleshield-v0.1 \
	telefire-v0.1 telefire-v0.2

ARMM3DIRS=\
	telemega-v0.1 telemega-v0.1/flash-loader \
	telemega-v1.0 telemega-v1.0/flash-loader \
	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
	megadongle-v0.1 megadongle-v0.1/flash-loader \
	telegps-v0.3 telegps-v0.3/flash-loader \
	telegps-v1.0 telegps-v1.0/flash-loader \
	telelco-v0.2 telelco-v0.2/flash-loader \
	telescience-v0.2 telescience-v0.2/flash-loader \
	teleballoon-v2.0

ARMM0DIRS=\
	easymini-v1.0 easymini-v1.0/flash-loader

AVRDIRS=\
	telescience-v0.1 telescience-pwm micropeak nanopeak-v0.1

SUBDIRS=

ifeq ($(strip $(HAVE_PDCLIB)),yes)
PDCLIB=pdclib
CLEAN_PDCLIB=clean-pdclib
endif

ifeq ($(strip $(HAVE_SDCC)),yes)
SUBDIRS+=$(SDCCDIRS)
endif

ifeq ($(strip $(HAVE_ARM_M3_CC)),yes)
SUBDIRS+=$(ARMM3DIRS)
foo=bar
endif

ifeq ($(strip $(HAVE_ARM_M0_CC)),yes)
SUBDIRS+=$(ARMM0DIRS)
baz=bletch
endif

ifeq ($(strip $(HAVE_AVR_CC)),yes)
SUBDIRS += $(AVRDIRS)
endif

ALLDIRS=$(SDCCDIRS) $(ARMM3DIRS) $(ARMM0DIRS) $(AVRDIRS)

all: all-local all-recursive

RECURSIVE_TARGETS = all-recursive install-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(SUBDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

ALL_RECURSIVE_TARGETS = clean-recursive

$(ALL_RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(ALLDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

distclean:	clean

clean: clean-local clean-recursive

install: install-recursive

uninstall:

all-recursive: all-local

all-local: altitude.h altitude-pa.h ao_kalman.h ao_whiten.h $(PDCLIB)

altitude.h: make-altitude
	nickle $< > $@

altitude-pa.h: make-altitude-pa
	nickle $< > $@

ao_kalman.h: make-kalman kalman.5c kalman_filter.5c load_csv.5c matrix.5c
	bash $< kalman > $@

ao_whiten.h: make-whiten
	nickle $< > $@

clean-local: $(CLEAN_PDCLIB)
	rm -f altitude.h ao_kalman.h

pdclib:
	mkdir -p $(PDCLIB_ROOT)/include $(PDCLIB_ROOT)/lib 
	cd ../pdclib && make && make prefix=`pwd`/../pdclib-root install

clean-pdclib:
	rm -rf $(PDCLIB_ROOT)
	cd ../pdclib && make clean

=== src/easymega-v0.1/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_companion.h \
	ao_data.h \
	ao_sample.h \
	ao_pins.h \
	altitude-pa.h \
	ao_kalman.h \
	ao_product.h \
	ao_ms5607.h \
	ao_hmc5883.h \
	ao_mpu6000.h \
	ao_mma655x.h \
	ao_profile.h \
	ao_task.h \
	ao_whiten.h \
	ao_sample_profile.h \
	ao_quaternion.h \
	math.h \
	ao_mpu.h \
	stm32l.h \
	math.h \
	Makefile

#
# Common AltOS sources
#
#	ao_hmc5883.c

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#SAMPLE_PROFILE=ao_sample_profile.c \
#	ao_sample_profile_timer.c
#SAMPLE_PROFILE_DEF=-DHAS_SAMPLE_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1

MATH_SRC=\
	ef_acos.c \
	ef_sqrt.c \
	ef_rem_pio2.c \
	kf_cos.c \
	kf_sin.c \
	kf_rem_pio2.c \
	sf_copysign.c \
	sf_cos.c \
	sf_fabs.c \
	sf_floor.c \
	sf_scalbn.c \
	sf_sin.c \
	ef_log.c

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_led.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_ignite.c \
	ao_freq.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_data.c \
	ao_ms5607.c \
	ao_mma655x.c \
	ao_hmc5883.c \
	ao_adc_stm.c \
	ao_beep_stm.c \
	ao_eeprom_stm.c \
	ao_storage.c \
	ao_m25.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_report.c \
	ao_i2c_stm.c \
	ao_mpu6000.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_log.c \
	ao_log_mega.c \
	ao_sample.c \
	ao_kalman.c \
	ao_flight.c \
	ao_companion.c \
	ao_pyro.c \
	$(MATH_SRC) \
	$(PROFILE) \
	$(SAMPLE_PROFILE) \
	$(STACK_GUARD)

PRODUCT=EasyMega-v0.1
PRODUCT_DEF=-DEASYMEGA
IDPRODUCT=0x0023

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF) -Os -g

PROGNAME=easymega-v0.1
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_easymega.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

../altitude-pa.h: make-altitude-pa
	nickle $< > $@

$(OBJ): $(INC)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/megadongle-v0.1/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_pins.h \
	ao_product.h \
	ao_cc1120_CC1120.h \
	ao_task.h \
	ao_whiten.h \
	stm32l.h \
	Makefile

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#SAMPLE_PROFILE=ao_sample_profile.c \
#	ao_sample_profile_timer.c
#SAMPLE_PROFILE_DEF=-DHAS_SAMPLE_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_led.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_freq.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_cc1120.c \
	ao_fec_tx.c \
	ao_fec_rx.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_monitor.c \
	ao_rssi.c \
	ao_send_packet.c \
	ao_packet_master.c \
	ao_packet.c

PRODUCT=MegaDongle-v0.1
PRODUCT_DEF=-DMEGADONGLE
IDPRODUCT=0x0024

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF) -Os -g

PROGNAME=megadongle-v0.1
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_megadongle.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/micropeak/Makefile ===
#
# Tiny AltOS build
#
#
vpath % ../attiny:../drivers:../kernel:../product:..
vpath ao-make-product.5c ../util
vpath make-altitude-pa ../util

include ../avr/Makefile.defs

PUBLISH_DIR=$(HOME)/altusmetrumllc/Binaries
PUBLISH_FILE=$(PUBLISH_DIR)/$(PROG)-$(VERSION).hex

MCU=attiny85
DUDECPUTYPE=t85
#PROGRAMMER=stk500v2 -P usb
LOADSLOW=-i 32 -B 32
LOADARG=-p $(DUDECPUTYPE) -c $(PROGRAMMER) -e -U flash:w:

#LDFLAGS=-L$(LDSCRIPTS) -Tavr25.x

ALTOS_SRC = \
	ao_micropeak.c \
	ao_spi_attiny.c \
	ao_led.c \
	ao_clock.c \
	ao_ms5607.c \
	ao_exti.c \
	ao_convert_pa.c \
	ao_report_micro.c \
	ao_notask.c \
	ao_eeprom_tiny.c \
	ao_panic.c \
	ao_log_micro.c \
	ao_async.c \
	ao_microflight.c \
	ao_microkalman.c

INC=\
	ao.h \
	ao_pins.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_exti.h \
	ao_ms5607.h \
	ao_log_micro.h \
	ao_micropeak.h \
	altitude-pa.h

IDPRODUCT=0
PRODUCT=MicroPeak-v0.1
PRODUCT_DEF=-DMICROPEAK
CFLAGS = $(PRODUCT_DEF) -I. -I../attiny -I../kernel -I.. -I../drivers -I../product
CFLAGS += -g -mmcu=$(MCU) -Wall -Wstrict-prototypes -O2 -mcall-prologues -DATTINY

NICKLE=nickle

PROG=micropeak-v0.1

SRC=$(ALTOS_SRC)
OBJ=$(SRC:.c=.o)

V=0
# The user has explicitly enabled quiet compilation.
ifeq ($(V),0)
quiet = @printf "  $1 $2 $@\n"; $($1)
endif
# Otherwise, print the full command line.
quiet ?= $($1)

all: $(PROG) $(PROG).hex

CHECK=sh ../util/check-avr-mem

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ)
	$(call quiet,CHECK) $(PROG) || ($(RM) -f $(PROG); exit 1)

$(PROG).hex: $(PROG)
	avr-size $(PROG)
	$(OBJCOPY) -R .eeprom -O ihex $(PROG) $@


load: $(PROG).hex
	$(LOADCMD) $(LOADARG)$(PROG).hex

load-slow: $(PROG).hex
	$(LOADCMD) $(LOADSLOW) $(LOADARG)$(PROG).hex

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

ao_product.o: ao_product.c ao_product.h

%.o : %.c $(INC)
	$(call quiet,CC) -c $(CFLAGS) $<

distclean:	clean

clean:
	rm -f *.o $(PROG) $(PROG).hex
	rm -f ao_product.h


publish: $(PROG).hex
	cp -a $(PROG).hex $(PUBLISH_FILE)

load-product:
	$(LOADCMD) $(LOADARG)$(PUBLISH_FILE)

load-product-slow:
	$(LOADCMD) $(LOADSLOW) $(LOADARG)$(PUBLISH_FILE)

../altitude-pa.h: make-altitude-pa
	nickle $< > $@

install:

uninstall:

$(OBJ): ao_product.h $(INC)

=== src/telefire-v0.1/Makefile ===
#
# TeleFire build file
#

TELEFIRE_VER=0.1
TELEFIRE_DEF=0_1

vpath %.c ..:../kernel:../cc1111:../drivers:../product
vpath %.h ..:../kernel:../cc1111:../drivers:../product
vpath ao-make-product.5c ../util

ifndef VERSION
include ../Version
endif

INC = \
	ao.h \
	ao_pins.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pad.h \
	cc1111.h \
	ao_product.h

CORE_SRC = \
	ao_cmd.c \
	ao_config.c \
	ao_convert.c \
	ao_mutex.c \
	ao_panic.c \
	ao_stdio.c \
	ao_storage.c \
	ao_task.c \
	ao_freq.c

CC1111_SRC = \
	ao_adc.c \
	ao_aes.c \
	ao_beep.c \
	ao_dma.c \
	ao_intflash.c \
	ao_radio.c \
	ao_radio_cmac.c \
	ao_romconfig.c \
	ao_serial.c \
	ao_spi.c \
	ao_string.c \
	ao_timer.c \
	ao_usb.c \
	_bp.c

DRIVER_SRC = \
	ao_pca9922.c \
	ao_74hc497.c \
	ao_pad.c \
	ao_radio_cmac_cmd.c

PRODUCT_SRC = \
	ao_telefire.c

SRC = \
	$(CORE_SRC) \
	$(CC1111_SRC) \
	$(DRIVER_SRC) \
	$(PRODUCT_SRC)

PROGNAME = telefire-v$(TELEFIRE_VER)
PROG = $(PROGNAME)-$(VERSION).ihx
PRODUCT=TeleFire-v$(TELEFIRE_VER)
PRODUCT_DEF=-DTELEFIRE_V_$(TELEFIRE_DEF)
IDPRODUCT=0x000f
CODESIZE=0x6700

include ../cc1111/Makefile.cc1111

NICKLE=nickle
CHECK_STACK=sh ../util/check-stack

V=0
# The user has explicitly enabled quiet compilation.
ifeq ($(V),0)
quiet = @printf "  $1 $2 $@\n"; $($1)
endif
# Otherwise, print the full command line.
quiet ?= $($1)

all: $(PROG)

$(PROG): $(REL) Makefile
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(REL)
	$(call quiet,CHECK_STACK) ../cc1111/ao_arch.h $(PMEM)  || rm $@

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean: clean-cc1111

install:

uninstall:

=== src/telefire-v0.2/Makefile ===
#
# TeleFire build file
#

TELEFIRE_VER=0.2
TELEFIRE_DEF=0_2

vpath %.c ..:../kernel:../cc1111:../drivers:../product
vpath %.h ..:../kernel:../cc1111:../drivers:../product
vpath ao-make-product.5c ../util

ifndef VERSION
include ../Version
endif

INC = \
	ao.h \
	ao_pins.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pad.h \
	cc1111.h \
	ao_product.h

CORE_SRC = \
	ao_cmd.c \
	ao_config.c \
	ao_convert.c \
	ao_mutex.c \
	ao_panic.c \
	ao_stdio.c \
	ao_storage.c \
	ao_task.c \
	ao_freq.c

CC1111_SRC = \
	ao_adc.c \
	ao_aes.c \
	ao_beep.c \
	ao_dma.c \
	ao_intflash.c \
	ao_radio.c \
	ao_radio_cmac.c \
	ao_romconfig.c \
	ao_serial.c \
	ao_spi.c \
	ao_string.c \
	ao_timer.c \
	ao_usb.c \
	_bp.c

DRIVER_SRC = \
	ao_pca9922.c \
	ao_74hc165.c \
	ao_pad.c \
	ao_radio_cmac_cmd.c

PRODUCT_SRC = \
	ao_telefire.c

SRC = \
	$(CORE_SRC) \
	$(CC1111_SRC) \
	$(DRIVER_SRC) \
	$(PRODUCT_SRC)

PROGNAME = telefire-v$(TELEFIRE_VER)
PROG = $(PROGNAME)-$(VERSION).ihx
PRODUCT=TeleFire-v$(TELEFIRE_VER)
PRODUCT_DEF=-DTELEFIRE_V_$(TELEFIRE_DEF)
IDPRODUCT=0x000f
CODESIZE=0x6700

include ../cc1111/Makefile.cc1111

NICKLE=nickle
CHECK_STACK=sh ../util/check-stack

V=0
# The user has explicitly enabled quiet compilation.
ifeq ($(V),0)
quiet = @printf "  $1 $2 $@\n"; $($1)
endif
# Otherwise, print the full command line.
quiet ?= $($1)

all: $(PROG)

$(PROG): $(REL) Makefile
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(REL)
	$(call quiet,CHECK_STACK) ../cc1111/ao_arch.h $(PMEM)  || rm $@

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean: clean-cc1111

install:

uninstall:

=== src/telemega-v1.0/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_companion.h \
	ao_data.h \
	ao_sample.h \
	ao_pins.h \
	altitude-pa.h \
	ao_kalman.h \
	ao_product.h \
	ao_ms5607.h \
	ao_hmc5883.h \
	ao_mpu6000.h \
	ao_mma655x.h \
	ao_cc1120_CC1120.h \
	ao_profile.h \
	ao_task.h \
	ao_whiten.h \
	ao_sample_profile.h \
	ao_quaternion.h \
	math.h \
	ao_mpu.h \
	stm32l.h \
	math.h \
	Makefile

#
# Common AltOS sources
#
#	ao_hmc5883.c

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#SAMPLE_PROFILE=ao_sample_profile.c \
#	ao_sample_profile_timer.c
#SAMPLE_PROFILE_DEF=-DHAS_SAMPLE_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1

MATH_SRC=\
	ef_acos.c \
	ef_sqrt.c \
	ef_rem_pio2.c \
	kf_cos.c \
	kf_sin.c \
	kf_rem_pio2.c \
	sf_copysign.c \
	sf_cos.c \
	sf_fabs.c \
	sf_floor.c \
	sf_scalbn.c \
	sf_sin.c \
	ef_log.c

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_led.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_serial_stm.c \
	ao_gps_ublox.c \
	ao_gps_show.c \
	ao_gps_report_mega.c \
	ao_ignite.c \
	ao_freq.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_cc1120.c \
	ao_fec_tx.c \
	ao_fec_rx.c \
	ao_data.c \
	ao_ms5607.c \
	ao_mma655x.c \
	ao_hmc5883.c \
	ao_adc_stm.c \
	ao_beep_stm.c \
	ao_eeprom_stm.c \
	ao_storage.c \
	ao_m25.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_report.c \
	ao_i2c_stm.c \
	ao_mpu6000.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_log.c \
	ao_log_mega.c \
	ao_sample.c \
	ao_kalman.c \
	ao_flight.c \
	ao_telemetry.c \
	ao_packet_slave.c \
	ao_packet.c \
	ao_companion.c \
	ao_pyro.c \
	ao_aprs.c \
	$(MATH_SRC) \
	$(PROFILE) \
	$(SAMPLE_PROFILE) \
	$(STACK_GUARD)

PRODUCT=TeleMega-v1.0
PRODUCT_DEF=-DTELEMEGA
IDPRODUCT=0x0023

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF) -Os -g

PROGNAME=telemega-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_telemega.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

../altitude-pa.h: make-altitude-pa
	nickle $< > $@

$(OBJ): $(INC)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/telemini-v2.0/Makefile ===
#
# TeleMini build file
#

TELEMINI_VER=2.0
TELEMINI_DEF=2_0

vpath %.c ..:../kernel:../cc1111:../drivers:../product
vpath %.h ..:../kernel:../cc1111:../drivers:../product
vpath ao-make-product.5c ../util

ifndef VERSION
include ../Version
endif

INC = \
	ao.h \
	ao_pins.h \
	ao_arch.h \
	ao_arch_funcs.h \
	cc1111.h \
	ao_ms5607.h \
	ao_ms5607_convert_8051.c \
	ao_product.h \
	ao_int64.h \
	ao_sample.h \
	ao_exti.h \
	ao_task.h

CORE_SRC = \
	ao_cmd.c \
	ao_config.c \
	ao_flight.c \
	ao_kalman.c \
	ao_log.c \
	ao_log_mini.c \
	ao_mutex.c \
	ao_panic.c \
	ao_report.c \
	ao_sample.c \
	ao_stdio.c \
	ao_storage.c \
	ao_task.c \
	ao_telemetry.c \
	ao_freq.c \
	ao_int64.c

CC1111_SRC = \
	ao_adc.c \
	ao_dma.c \
	ao_ignite.c \
	ao_led.c \
	ao_packet.c \
	ao_packet_slave.c \
	ao_radio.c \
	ao_romconfig.c \
	ao_string.c \
	ao_spi.c \
	ao_usb.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_beep.c \
	ao_timer.c \
	ao_exti.c \
	_bp.c

DRIVER_SRC = \
	ao_ms5607.c \
	ao_m25.c

PRODUCT_SRC = \
	ao_telemini.c

SRC = \
	$(CORE_SRC) \
	$(CC1111_SRC) \
	$(DRIVER_SRC) \
	$(PRODUCT_SRC)

PROGNAME = telemini-v$(TELEMINI_VER)
PROG = $(PROGNAME)-$(VERSION).ihx
PRODUCT=TeleMini-v$(TELEMINI_VER)
PRODUCT_DEF=-DTELEMINI_V_$(TELEMINI_DEF)
IDPRODUCT=0x0027

include ../cc1111/Makefile.cc1111

NICKLE=nickle
CHECK_STACK=sh ../util/check-stack

V=0
# The user has explicitly enabled quiet compilation.
ifeq ($(V),0)
quiet = @printf "  $1 $2 $@\n"; $($1)
endif
# Otherwise, print the full command line.
quiet ?= $($1)

all: $(PROG)

$(PROG): $(REL) Makefile
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(REL)
	$(call quiet,CHECK_STACK) ../cc1111/ao_arch.h $(PMEM) || rm $@

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean: clean-cc1111

install:

uninstall:

=== src/test/Makefile ===
vpath % ..:../kernel:../drivers:../util:../micropeak:../aes:../product

PROGS=ao_flight_test ao_flight_test_baro ao_flight_test_accel ao_flight_test_noisy_accel ao_flight_test_mm \
	ao_gps_test ao_gps_test_skytraq ao_gps_test_ublox ao_convert_test ao_convert_pa_test ao_fec_test \
	ao_aprs_test ao_micropeak_test ao_fat_test ao_aes_test ao_int64_test \
	ao_ms5607_convert_test ao_quaternion_test

INCS=ao_kalman.h ao_ms5607.h ao_log.h ao_data.h altitude-pa.h altitude.h ao_quaternion.h

KALMAN=make-kalman 

CFLAGS=-I.. -I. -I../kernel -I../drivers -I../micropeak -I../product -O0 -g -Wall

all: $(PROGS) ao_aprs_data.wav

clean:
	rm -f $(PROGS) ao_aprs_data.wav run-out.baro run-out.full

install:

ao_flight_test: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c altitude.h $(INCS)
	cc $(CFLAGS) -o $@ $<

ao_flight_test_noisy_accel: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c $(INCS)
	cc -DNOISY_ACCEL=1 $(CFLAGS) -o $@ $<

ao_flight_test_baro: ao_flight_test.c ao_host.h ao_flight.c  ao_sample.c ao_kalman.c $(INCS)
	cc $(CFLAGS) -o $@ -DHAS_ACCEL=0 ao_flight_test.c

ao_flight_test_accel: ao_flight_test.c ao_host.h ao_flight.c  ao_sample.c ao_kalman.c $(INCS)
	cc $(CFLAGS) -o $@ -DFORCE_ACCEL=1 ao_flight_test.c

ao_flight_test_mm: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c ao_pyro.c ao_pyro.h $(INCS)
	cc -DTELEMEGA=1 $(CFLAGS) -o $@ $< -lm

ao_gps_test: ao_gps_test.c ao_gps_sirf.c ao_gps_print.c ao_host.h
	cc $(CFLAGS) -o $@ $<

ao_gps_test_skytraq: ao_gps_test_skytraq.c ao_gps_skytraq.c ao_gps_print.c ao_gps_show.c ao_host.h
	cc $(CFLAGS) -o $@ $<

ao_gps_test_ublox: ao_gps_test_ublox.c ao_gps_ublox.c ao_gps_print.c ao_gps_show.c ao_host.h ao_gps_ublox.h
	cc $(CFLAGS) -o $@ $<

ao_convert_test: ao_convert_test.c ao_convert.c altitude.h
	cc $(CFLAGS) -o $@ $<

ao_convert_pa_test: ao_convert_pa_test.c ao_convert_pa.c altitude-pa.h
	cc $(CFLAGS) -o $@ $<

ao_kalman.h: $(KALMAN)
	(cd .. && make ao_kalman.h)

ao_fec_test: ao_fec_test.c ao_fec_tx.c ao_fec_rx.c
	cc $(CFLAGS) -DAO_FEC_DEBUG=1 -o $@ ao_fec_test.c ../kernel/ao_fec_tx.c ../kernel/ao_fec_rx.c -lm

ao_aprs_test: ao_aprs_test.c ao_aprs.c
	cc $(CFLAGS) -o $@ ao_aprs_test.c -lm

SOX_INPUT_ARGS=--type raw --encoding unsigned-integer -b 8 -c 1 -r 9600
SOX_OUTPUT_ARGS=--type wav

ao_aprs_data.wav: ao_aprs_test
	./ao_aprs_test | sox $(SOX_INPUT_ARGS) - $(SOX_OUTPUT_ARGS) $@

check: ao_fec_test ao_flight_test ao_flight_test_baro run-tests
	./ao_fec_test && ./run-tests

ao_micropeak_test: ao_micropeak_test.c ao_microflight.c ao_kalman.h
	cc $(CFLAGS) -o $@ ao_micropeak_test.c -lm

ao_fat_test: ao_fat_test.c ao_fat.c ao_bufio.c
	cc $(CFLAGS) -o $@ ao_fat_test.c -lssl -lcrypto

ao_aes_test: ao_aes_test.c ao_aes.c ao_aes_tables.c
	cc $(CFLAGS) -o $@ ao_aes_test.c

ao_int64_test: ao_int64_test.c ao_int64.c ao_int64.h
	cc $(CFLAGS) -o $@ ao_int64_test.c

ao_ms5607_convert_test: ao_ms5607_convert_test.c ao_ms5607_convert_8051.c ao_int64.c ao_int64.h
	cc $(CFLAGS) -o $@ ao_ms5607_convert_test.c

ao_quaternion_test: ao_quaternion_test.c ao_quaternion.h
	cc $(CFLAGS) -o $@ ao_quaternion_test.c -lm

=== src/easymega-v0.1/flash-loader/Makefile ===
#
# AltOS flash loader build
#
#

TOPDIR=../..
HARDWARE=easymega-v0.1
include $(TOPDIR)/stm/Makefile-flash.defs

=== debian/changelog ===
altos (1.4.1-1) unstable; urgency=medium

  [ Keith Packard ]
  * Sign our .inf file with the comodo key. Update signing-driver
  * Fix java version detection and downloading
  * altosui: Ship TeleMetrum v2.0 firmware with AltosUI
  * Add 1.4.1 release notes
  * Add note about including Google maps API key
  * altosuilib: Mark 'Configure AltosUI' window with maps key status

  [ Bdale Garbee ]
  * notes updated for TeleGPS and 1.4 release learnings
  * make sure to use Google Maps API key for official builds
  * need the api key in Bdale's root too
  * releasing 1.4.1
  * update ChangeLog for release

 -- Bdale Garbee <bdale@gag.com>  Tue, 24 Jun 2014 21:57:12 -0600

altos (1.4-1) unstable; urgency=medium

  [ Keith Packard ]
  * Add linux installer script
  * Put altusmetrum.svg and micropeak.svg in icon directory
  * Move .desktop and icon management out of debian dir
  * micropeak: Construct linux install script
  * Mark .desktop files as executable
  * Re-create drill templates
  * doc: Need to publish .svg files as well
  * altos: Move balloon flight code to core
  * altos: Expose ao_usb_running globally
  * altos: Set reasonable accel values when !HAS_ACCEL
  * altos: Make balloon code run again
  * altos: Create balloon-specific load for TMv2 hardware
  * libaltos: Link so with -znoexecstack flag
  * Mark development sequence to 1.3.3 by bumping version to 1.3.2.1
  * altosui: Retry device enumeration after rebooting for self flash
  * Install .desktopfile as _SCRIPTS so they are left executable
  * doc: Add separate outline pdf generation
  * Add flash loader for stm-demo board
  * Re-add LCD bits to stm-demo
  * Add USB True Random Number Generator product
  * altos: Don't require projects to define PACKET_HAS_SLAVE
  * altos: fix building LPC serial support for STDIO
  * altos: Fix LPC LED driver
  * altos: Missing ao_pins files for usbtrng
  * altos: Another missing usbtrng file
  * altosui: Hide Tilt Angle values when not available
  * Add easymega firmware
  * altos: HAS_LED is useless; remove it
  * altoslib: Ignore speed/accel after boost when finding maxima
  * altoslib: Fix EasyMini voltage computations
  * Add easymini turnon script and helpers
  * altoslib: Missed a couple of easy mini voltage API changes
  * altos: Rename 'core' to 'kernel'
  * ao-bringup: Get turnon_telemini working
  * ao-tools: Use 'program' command in ao-flash-lpc instead of 'flash'
  * ao-tools: Wait for device to become ready instead of failing
  * doc: Outline files are now generated, so don't put them in git
  * altos: Report battery voltage instead of S at startup
  * Bump version to 1.3.3
  * doc: Document new voltage beeping at startup time
  * altosui: Add ignitor tab for TeleMega extra ignitors
  * ao-bringup: Split out easymini test into separate script
  * altos: Build TeleBalloon v2.0 by default
  * altos: Replace C code attiny async output with inline asm
  * altos: Provide stable binaries for MicroPeak
  * altos: Fix nanopeak compile
  * altosui: Disable flight log configuration while flights are stored
  * altos: Add 'microwater' product
  * altoslib/altosui/altosuilib/libaltos: Remove trailing whitespace
  * altosuilib: Make lines in graphs 2 units wide
  * altos: Switch beeping to farnsworth spacing
  * altosui: Add extra ignitors to graphable objects
  * altoslib: Track pyro firing state when reading mega eeprom files
  * altosui: Mark TeleMega additional pyro ignitor fired points in graphs
  * ao-telem: Dump orientation field from TeleMega sensor telemetry packet
  * ao-load: Make ao_sym static to avoid collision with ao-editaltos
  * ao-tools: Clean up ao-sym structure an initializers
  * altos: For telelco discovery packets, retry 5 times with shorter timeout
  * altos: Add configurable beep tone
  * altosui: Add configuration UI for beeper tone
  * altos: 8051 64 * 16 multiply function was broken for negative 64-bit
  * altoslib: Add a comment to remind us to fix the IMU code to deal with calibration
  * altoslib: Parse remaining mega AO_LOG_FLIGNT and AO_LOG_GPS_TIME fields
  * altosui: Add GPS course, ground speed and climb rate to graphs
  * altos: ublox driver always offers course data when it has a fix
  * altos: Fix byte offsets in the mega AO_LOG_FLIGHT packets
  * altos: Clean up trailing whitespace in ao_pad.c
  * altos: Simplify quadrature tracking
  * atosui: Hide Callsign and RSSI tabs for devices without a radio
  * ao-bringup: test-baro should accept altitudes a bit below sea level
  * ao-bringup: Use official binaries for EasyMini turnon
  * altos: Add LED test command to pca9922 driver
  * altos: Report amount of program space available in the version command
  * altos: Assume all LPC products will have 32KB of flash
  * altos/stm: Use flash address of boot loader instead of 0x0
  * altos/stm: White space fix in ao_boot_pin.c
  * altos/stm: Figure out available flash space based on chip id registers
  * altos/stm: Use #define'd constants for GPIO register addresses
  * altos/flash-loader: Check memory addresses against flash space
  * ao-tools/ao-usbload: Check image flash usage against device flash availability
  * altos/cc1111: Wait for xtal to be stable
  * altos/cc1111: Errata fix isn't needed for discontinued products
  * altos/cc1111: Add support for CPU-driven USB pullup
  * altos/cc1111: Switch P1_0 from a green LED to USB pullup
  * altos/telemini-v2.0: Remove old baro->alt conversion table
  * altos/telemini-v2.0: Enable beep frequency configuration
  * altos: Make quadrature debounce per-pin rather than per-device
  * doc: Document the Apogee Lockout setting
  * altos: Use explicit boot loader signal in ao_boot_reboot
  * altos: stm and lpc ao_boot.h were identical. move to kernel.
  * altosui: Remove debug printf about beep config
  * altosui: Remove another beep config debug printf
  * altos/stm: Make stm applications depend on ao_boot.h
  * altos/lpc: adc code computes number of active ADC channels
  * altos/lpc: whitespace


=== debian/control ===
Source: altos
Section: electronics
Priority: optional
Maintainer: Bdale Garbee <bdale@gag.com>
Uploaders: Keith Packard <keithp@keithp.com>
Build-Depends: debhelper (>= 7), autoconf, automake, gawk, libreadline-dev, libusb-1.0-0-dev, nickle, cc1111, xsltproc, fop, xmlto, docbook-xml, docbook-xsl, swig, default-jdk, freetts, libtool, libjfreechart-java, libbluetooth-dev, pkg-config, libelf-dev, libbluetooth-dev, libssl-dev, gcc-arm-none-eabi, icoutils, librsvg2-bin, icnsutils, graphicsmagick | imagemagick
Standards-Version: 3.9.5
Homepage: http://altusmetrum.org/AltOS
Vcs-Git: git://git.gag.com/fw/altos
Vcs-Browser: http://git.gag.com/?p=fw/altos

Package: altos
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, default-jre | java2-runtime, freetts, nickle, libjfreechart-java
Suggests: slim | gdm
Replaces: altusmetrum-themes, slim-altusmetrum
Conflicts: altusmetrum-themes, slim-altusmetrum
Description: Altus Metrum firmware and utilities
 Firmware and utilities needed to support high power model rocketry products
 from Altus Metrum, including TeleMetrum, TeleMini, and TeleDongle.
 .
 See http://altusmetrum.org/ for more information.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
PKG_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)/\1/p')

# this target invoked by git-buildpackage using a clean hook, see .gbp.conf
prebuild:
	echo "not frobbing changelog for official builds"

configure: configure-stamp
configure-stamp:
	dh_testdir
	PKG_CONFIG_PATH=/opt/stlink/lib/pkgconfig ./autogen.sh \
		--prefix=/usr --with-google-key=/opt/google/maps-api-key
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp  
	dh_testdir
	$(MAKE)
	(cd doc ; $(MAKE))
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep  
	dh_installdirs

	$(MAKE) DESTDIR=$(CURDIR)/debian/altos install
	sed -i "/dependency_libs/ s/'.*'/''/" `find debian/altos/usr/lib/altos/ -name '*.la'`

binary-indep: install

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_install
	ln -s /usr/share/altos/themes/background.png \
		debian/altos/usr/share/gdm/themes/altusmetrum/background.png
	ln -s /usr/share/altos/themes/background.png \
		debian/altos/usr/share/slim/themes/altusmetrum/background.png
	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## altos 1.5

=== doc/Makefile ===
--- 
+++ 
@@ -16,7 +16,8 @@
 	release-notes-1.3.1.html \
 	release-notes-1.3.2.html \
 	release-notes-1.4.html \
-	release-notes-1.4.1.html
+	release-notes-1.4.1.html \
+	release-notes-1.5.html
 
 PICTURES=\
 	altosui.png \
@@ -61,12 +62,13 @@
 	easymini.svg \
 	telemega.svg \
 	telemetrum.svg \
-	telemini.svg
+	telemini.svg \
+	easymega.svg
 
 RELNOTES_XSL=$(RELNOTES:.html=.xsl)
 HTML=altusmetrum.html altos.html telemetry.html companion.html micropeak.html telegps.html $(RELNOTES)
 PDF=altusmetrum.pdf altos.pdf telemetry.pdf companion.pdf micropeak.pdf telegps.pdf \
-	telemetrum-outline.pdf telemega-outline.pdf easymini-outline.pdf
+	telemetrum-outline.pdf telemega-outline.pdf easymini-outline.pdf easymega-outline.pdf
 HTMLSTYLE=/usr/share/xml/docbook/stylesheet/docbook-xsl/html/docbook.xsl
 FOSTYLE=xorg-fo.xsl
 TEMPLATES=titlepage.templates.xsl

=== src/Makefile ===
--- 
+++ 
@@ -22,9 +22,11 @@
 	telemini-v1.0 telemini-v2.0 \
 	telebt-v1.0 \
 	teleterra-v0.2 teleshield-v0.1 \
-	telefire-v0.1 telefire-v0.2
+	telefire-v0.1 telefire-v0.2 \
+	telerepeat-v1.0
 
 ARMM3DIRS=\
+	easymega-v1.0 easymega-v1.0/flash-loader \
 	telemega-v0.1 telemega-v0.1/flash-loader \
 	telemega-v1.0 telemega-v1.0/flash-loader \
 	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
@@ -39,7 +41,7 @@
 	easymini-v1.0 easymini-v1.0/flash-loader
 
 AVRDIRS=\
-	telescience-v0.1 telescience-pwm micropeak nanopeak-v0.1
+	telescience-v0.1 telescience-pwm micropeak nanopeak-v0.1 microkite
 
 SUBDIRS=
 
@@ -98,7 +100,7 @@
 
 all-recursive: all-local
 
-all-local: altitude.h altitude-pa.h ao_kalman.h ao_whiten.h $(PDCLIB)
+all-local: altitude.h altitude-pa.h altitude-pa-small.h ao_kalman.h ao_whiten.h $(PDCLIB)
 
 altitude.h: make-altitude
 	nickle $< > $@
@@ -106,7 +108,10 @@
 altitude-pa.h: make-altitude-pa
 	nickle $< > $@
 
-ao_kalman.h: make-kalman kalman.5c kalman_filter.5c load_csv.5c matrix.5c
+altitude-pa-small.h: make-altitude-pa
+	nickle $< --sample 3 > $@
+
+ao_kalman.h: make-kalman kalman.5c kalman_micro.5c kalman_filter.5c load_csv.5c matrix.5c
 	bash $< kalman > $@
 
 ao_whiten.h: make-whiten

=== src/microwater/Makefile ===
#
# Tiny AltOS build
#
#
vpath % ../attiny:../drivers:../kernel:../product:..
vpath ao-make-product.5c ../util
vpath make-altitude-pa ../util

include ../avr/Makefile.defs

PUBLISH_DIR=$(HOME)/altusmetrumllc/Binaries
PUBLISH_FILE=$(PUBLISH_DIR)/$(PROG)-$(VERSION).hex

MCU=attiny85
DUDECPUTYPE=t85
#PROGRAMMER=stk500v2 -P usb
LOADSLOW=-i 32 -B 32
LOADARG=-p $(DUDECPUTYPE) -c $(PROGRAMMER) -e -U flash:w:

#LDFLAGS=-L$(LDSCRIPTS) -Tavr25.x

ALTOS_SRC = \
	ao_micropeak.c \
	ao_spi_attiny.c \
	ao_led.c \
	ao_clock.c \
	ao_ms5607.c \
	ao_exti.c \
	ao_convert_pa.c \
	ao_report_micro.c \
	ao_notask.c \
	ao_eeprom_tiny.c \
	ao_panic.c \
	ao_log_micro.c \
	ao_async.c \
	ao_microflight.c \
	ao_microkalman.c

INC=\
	ao.h \
	ao_pins.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_exti.h \
	ao_ms5607.h \
	ao_log_micro.h \
	ao_micropeak.h \
	altitude-pa.h

IDPRODUCT=0
PRODUCT=MicroWater-v0.1
PRODUCT_DEF=-DMICROPEAK
CFLAGS = $(PRODUCT_DEF) -I. -I../attiny -I../kernel -I.. -I../drivers -I../product
CFLAGS += -g -mmcu=$(MCU) -Wall -Wstrict-prototypes -O2 -mcall-prologues -DATTINY

NICKLE=nickle

PROG=microwater-v0.1

SRC=$(ALTOS_SRC)
OBJ=$(SRC:.c=.o)

V=0
# The user has explicitly enabled quiet compilation.
ifeq ($(V),0)
quiet = @printf "  $1 $2 $@\n"; $($1)
endif
# Otherwise, print the full command line.
quiet ?= $($1)

all: $(PROG) $(PROG).hex

CHECK=sh ../util/check-avr-mem

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ)
	$(call quiet,CHECK) $(PROG) || ($(RM) -f $(PROG); exit 1)

$(PROG).hex: $(PROG)
	avr-size $(PROG)
	$(OBJCOPY) -R .eeprom -O ihex $(PROG) $@


load: $(PROG).hex
	$(LOADCMD) $(LOADARG)$(PROG).hex

load-slow: $(PROG).hex
	$(LOADCMD) $(LOADSLOW) $(LOADARG)$(PROG).hex

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

ao_product.o: ao_product.c ao_product.h

%.o : %.c $(INC)
	$(call quiet,CC) -c $(CFLAGS) $<

distclean:	clean

clean:
	rm -f *.o $(PROG) $(PROG).hex
	rm -f ao_product.h


publish: $(PROG).hex
	cp -a $(PROG).hex $(PUBLISH_FILE)

load-product:
	$(LOADCMD) $(LOADARG)$(PUBLISH_FILE)

load-product-slow:
	$(LOADCMD) $(LOADSLOW) $(LOADARG)$(PUBLISH_FILE)

../altitude-pa.h: make-altitude-pa
	nickle $< > $@

install:

uninstall:

$(OBJ): ao_product.h $(INC)

=== debian/changelog ===
altos (1.5-1) unstable; urgency=medium

  [ Bdale Garbee ]
  * notes updated for TeleGPS and 1.4 release learnings
  * make sure to use Google Maps API key for official builds
  * need the api key in Bdale's root too
  * update Releasing file based on learnings from 1.4.1 release
  * Windows sucks, hard .. make sure filenames are legal in .mdwn files
  * note need to push the updated repo with production binaries during release
  * update turnon tools
  * change easymega from v0.1 to v1.0, tweak to build on master, add to Makefile
  * turn echo back on after accel cal in turnon_telemetrum so rest is easier
  * tweaking test scripts
  * releasing version 1.5
  * updated ChangeLog for 1.5 release
  * update changelog for Debian build
  * capture deleted file
  * more build dependencies for processing icons
  * more build dependencies for processing icons
  * update ChangeLog
  * update changelog for Debian build
  * another build dep
  * use dh_installmime, which requires telling configure to stay out of the way
  * another build dep
  * use dh_installmime, which requires telling configure to stay out of the way
  * update changelog for release
  * update changelog for Debian build
  * need multi-arch in fat build
  * ignore cal_values file in bringup directory
  * updated ChangeLog for release

  [ Keith Packard ]
  * doc: Add instructions for flash recovery technique
  * altos/micropeak: Create a script to load firmware.
  * altosui/telegps: Use menus for frequency list and telemetry formats
  * altosuilib: Move menu bars into the Mac OS X top bar
  * altosui: Fix ground station configure frequency list
  * java: Bump java library versions for next release
  * altos/micropeak: Add load script template
  * Sign our .inf file with the comodo key. Update signing-driver
  * Fix java version detection and downloading
  * icon: Construct .exe files to hold windows icons for file associations
  * windows installer: Create file associations for Windows.
  * macosx: Define icons for our file types on OS X
  * altosui: Ship TeleMetrum v2.0 firmware with AltosUI
  * altosuilib: Hook up apple messages to callbacks
  * macosx: Respond to apple messages in all apps
  * windows: Missed adding 'refresh-sh.nsh'
  * linux: .desktop files must begin with organization name
  * Rename icon files to fit XDG specifications. Add file icons. Add mime types
  * altosuilib: Wrap radio frequency menu in JMenuBar when used in config
  * altos/aprs: Encode last serial number in SSID. Transmit serial in comment
  * altosui: Add Ignitor tab to Monitor Idle mode
  * altos: Make APRS SSID configurable
  * altosui/telegps: Expose configurable APRS SSID
  * ao-tools: Add ao-test-baro, ao-test-igniter and ao-test-flash
  * ao-bringup: Use the C tools to test EasyMini
  * altos: Add optional debugging to print out pyro firing status
  * altos/ao_flight_test: Get the Tmega version compiling again
  * Bump version to 1.4.1.1
  * altosuilib: Make map cache size configurable
  * altosuilib: Outline map lines and distance value with white
  * icon: Generate altusmetrum.xpm and install it
  * altosuilib: Mark 'Configure AltosUI' window with maps key status
  * Clean all .desktop files, ignore them too
  * Add 1.4.1 release notes
  * Add note about including Google maps API key
  * altosui: Don't show the tracker motion value when switching units
  * telegps: Disable tracker config when not available
  * altosui/telegps: Undo the frequency/telemetry menu changes
  * altoslib: Disable telemetry while getting config data
  * altoslib: Preserve receiver_serial across state reset for new transmitter
  * altosuilib: Remove debug printfs from map cache
  * altos: ao_rssi subsystem needs to use AO_LED_TYPE instead of uint8_t
  * altos: Stop sticking cc1111 firmware in src directory
  * altos: Use TeleMetrum v1.9 board for MegaDongle experiments
  * altos: Reduce configuration data telemetry to once per 5 seconds
  * altos: Add defines for 2400 and 9600 baud telemetry rates
  * altos: Add config support for 2400 and 9600 baud telemetry rates
  * altos: Call ao_telemetry_reset_interval when telemetry rate changes
  * altos/cc1111: Adjust receive parameters to improve sensitivity
  * altos/cc1111: Add 2400 and 9600 baud telemetry rate support
  * altos: Add 2400 and 9600 baud telemetry support to cc115l driver
  * altos: Packet reception tuning for cc1120 driver
  * altos: Add telemetry rate support to CC1120 driver
  * altos: Rework packet receive for cc1120
  * altoslib: Support multiple telemetry rates
  * altosuilib: Add telemetry rate to Scan UI
  * altosui: Support telemetry data rates
  * telegps: Support variable telemetry rate
  * Add support for the "kite" micropeak variant
  * Bump version to 1.4.9.1 -- on the way to 1.5
  * altosui: Hide inactive altimeter configuration entries
  * altos/telemini-v2.0: Add memory decorations to new telemetry variables
  * altos: Add smaller pa to altitude table for TeleMini
  * altos/telemini-v2.0: Enable beep config and radio rate config
  * micropeak/altosui/telegps: Fix icon file names
  * altoslib: Clean up GPS DOP support in AltosState
  * altoslib: Ensure CSV output is consistent
  * altosuilib: Add GPS DOP values to graph
  * altosuilib: Add GPS DOP values to info table
  * altosuilib: Allow for unitless axes in graphs
  * altos: Extend GPS altitudes to at least 24 bits everywhere
  * altoslib: Handle wide GPS altitude values in eeprom and telemetry
  * altos: Scale DOP values by 10 in GPS drivers
  * altos: Record pdop value in TeleMetrumV2 log
  * altos: Use 32-bits for flight state data (alt/speed/accel)
  * altosui: Fix the 'Graph' button on the landed tab
  * altoslib: Extend telemetry heights from 16 to 32 bits
  * libaltos: Bind to libbluetooth at runtime on demand
  * altosui: Don't show bluetooth UI bits on mac/windows
  * libaltos: typo in libaltos broke the build
  * telegps: Missing function in TeleGPSConfigUI
